import { defineComponent as b, openBlock as s, createElementBlock as a, createElementVNode as r, normalizeClass as n, Fragment as m, renderList as f, withModifiers as g, toDisplayString as l, createTextVNode as d, createCommentVNode as i } from "vue";
const $ = b({
  name: "Vue3TailwindPagination",
  data() {
    return {
      page_range: 2
    };
  },
  props: {
    current_page: {
      type: Number,
      default: 1
    },
    total: {
      type: Number,
      default: 79
    },
    per_page: {
      type: Number,
      default: 5
    },
    background: {
      type: String,
      default: "bg-gray-200"
    },
    active_background: {
      type: String,
      default: "bg-gray-900"
    },
    color: {
      type: String,
      default: "text-gray-500"
    },
    active_color: {
      type: String,
      default: "text-white"
    },
    border_color: {
      type: String,
      default: "border-transparent"
    },
    active_border_color: {
      type: String,
      default: "border-transparent"
    },
    show_text: {
      type: Boolean,
      default: !1
    },
    text: {
      type: Object,
      default: () => ({
        one: "Enregirstrements",
        two: "\xE0",
        three: "de",
        four: "resultats"
      })
    }
  },
  methods: {
    hasFirst() {
      return this.rangeStart !== 1;
    },
    hasLast() {
      return this.rangeEnd < this.total_pages;
    },
    showLast() {
      return this.rangeEnd < this.total_pages && this.total_pages - this.current_page > 2;
    },
    changePage(e) {
      e > 0 && e <= this.total_pages && this.$emit("change", e);
    },
    more() {
      this.changePage(this.current_page + this.page_range);
    },
    less() {
      this.changePage(this.current_page - this.page_range);
    }
  },
  computed: {
    pages() {
      let e = [];
      for (let t = this.rangeStart; t <= this.rangeEnd; t++)
        e.push(t);
      return e;
    },
    reducedData() {
      return this.pages[this.pages.length - 1] > 3 ? this.pages.slice(1) : this.pages;
    },
    rangeStart() {
      const e = this.current_page - this.page_range + 1;
      return e > 0 && e !== this.page_range ? e : 1;
    },
    rangeEnd() {
      const e = this.current_page + this.page_range - 1;
      return e + 1 <= this.total_pages ? e : this.total_pages;
    },
    total_pages() {
      return this.per_page >= 1 ? Math.ceil(this.total / this.per_page) : Math.ceil(this.total / 10);
    }
  }
}), k = (e, t) => {
  const u = e.__vccOpts || e;
  for (const [c, h] of t)
    u[c] = h;
  return u;
}, y = {
  key: 0,
  class: "bg-white px-4 py-3 flex items-center justify-between sm:px-6"
}, w = { class: "flex-1 flex justify-between md:hidden" }, _ = {
  class: "relative z-0 inline-flex rounded-md -space-x-px",
  "aria-label": "Pagination"
}, C = /* @__PURE__ */ r("span", { class: "sr-only" }, "Previous", -1), P = /* @__PURE__ */ r("svg", {
  class: "h-5 w-5 cursor-pointer",
  viewBox: "0 0 20 20",
  fill: "currentColor",
  "aria-hidden": "true"
}, [
  /* @__PURE__ */ r("path", {
    "fill-rule": "evenodd",
    d: "M12.707 5.293a1 1 0 010 1.414L9.414 10l3.293 3.293a1 1 0 01-1.414 1.414l-4-4a1 1 0 010-1.414l4-4a1 1 0 011.414 0z",
    "clip-rule": "evenodd"
  })
], -1), x = [
  C,
  P
], L = ["onClick"], S = /* @__PURE__ */ r("span", { class: "sr-only" }, "Next", -1), B = /* @__PURE__ */ r("svg", {
  class: "h-5 w-5 cursor-pointer",
  viewBox: "0 0 20 20",
  fill: "currentColor",
  "aria-hidden": "true"
}, [
  /* @__PURE__ */ r("path", {
    "fill-rule": "evenodd",
    d: "M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z",
    "clip-rule": "evenodd"
  })
], -1), M = [
  S,
  B
], E = { class: "hidden md:flex-1 md:flex md:items-center md:justify-between" }, N = { key: 0 }, z = { class: "text-sm text-gray-700" }, j = { class: "font-medium" }, F = { class: "font-medium" }, V = { class: "font-medium" }, D = {
  class: "relative z-0 inline-flex rounded-md -space-x-px",
  "aria-label": "Pagination"
}, T = /* @__PURE__ */ r("svg", {
  fill: "none",
  viewBox: "0 0 24 24",
  "stroke-width": "1.5",
  stroke: "currentColor",
  class: "w-5 h-5 cursor-pointer"
}, [
  /* @__PURE__ */ r("path", {
    "stroke-linecap": "round",
    "stroke-linejoin": "round",
    d: "M18.75 19.5l-7.5-7.5 7.5-7.5m-6 15L5.25 12l7.5-7.5"
  })
], -1), O = [
  T
], q = /* @__PURE__ */ r("span", { class: "sr-only" }, "Previous", -1), A = /* @__PURE__ */ r("svg", {
  class: "h-5 w-5 cursor-pointer",
  viewBox: "0 0 20 20",
  fill: "currentColor",
  "aria-hidden": "true"
}, [
  /* @__PURE__ */ r("path", {
    "fill-rule": "evenodd",
    d: "M12.707 5.293a1 1 0 010 1.414L9.414 10l3.293 3.293a1 1 0 01-1.414 1.414l-4-4a1 1 0 010-1.414l4-4a1 1 0 011.414 0z",
    "clip-rule": "evenodd"
  })
], -1), G = [
  q,
  A
], H = { key: 0 }, I = /* @__PURE__ */ r("span", null, "1", -1), J = [
  I
], K = ["onClick"], Q = /* @__PURE__ */ r("span", { class: "sr-only" }, "Next", -1), R = /* @__PURE__ */ r("svg", {
  class: "h-5 w-5 cursor-pointer",
  viewBox: "0 0 20 20",
  fill: "currentColor",
  "aria-hidden": "true"
}, [
  /* @__PURE__ */ r("path", {
    "fill-rule": "evenodd",
    d: "M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z",
    "clip-rule": "evenodd"
  })
], -1), U = [
  Q,
  R
], W = /* @__PURE__ */ r("svg", {
  fill: "none",
  viewBox: "0 0 24 24",
  "stroke-width": "1.5",
  stroke: "currentColor",
  class: "w-5 h-5 cursor-pointer"
}, [
  /* @__PURE__ */ r("path", {
    "stroke-linecap": "round",
    "stroke-linejoin": "round",
    d: "M11.25 4.5l7.5 7.5-7.5 7.5m-6-15l7.5 7.5-7.5 7.5"
  })
], -1), X = [
  W
];
function Y(e, t, u, c, h, Z) {
  return e.total_pages > 1 ? (s(), a("div", y, [
    r("div", w, [
      r("nav", _, [
        r("span", null, [
          r("a", {
            onClick: t[0] || (t[0] = (o) => e.changePage(1)),
            class: n(`relative mr-1 inline-flex rounded-full cursor-pointer shadow-xs text-sm items-center px-1 py-2 border ${e.border_color} ${e.background} text-sm font-medium ${e.color}`)
          }, " First ", 2)
        ]),
        r("span", null, [
          r("a", {
            onClick: t[1] || (t[1] = (o) => e.changePage(e.current_page - 1)),
            class: n(`relative mr-1 inline-flex rounded-full shadow-xs text-sm items-center px-2 py-2 border ${e.border_color} ${e.background} text-sm font-medium ${e.color}`)
          }, x, 2)
        ]),
        (s(!0), a(m, null, f(e.reducedData, (o, p) => (s(), a("span", { key: p }, [
          r("a", {
            class: n([[e.current_page === o ? `${e.active_background} ${e.active_color} border ${e.active_border_color}` : `${e.background} border ${e.border_color}`], "relative inline-flex items-center mr-1 px-4 py-2 rounded-full cursor-pointer shadow-xs text-sm"]),
            onClick: g((v) => e.changePage(o), ["prevent"])
          }, [
            r("span", {
              class: n([e.current_page === o ? "text-white" : ""])
            }, l(o), 3)
          ], 10, L)
        ]))), 128)),
        r("span", null, [
          r("a", {
            onClick: t[2] || (t[2] = (o) => e.changePage(e.current_page + 1)),
            class: n(`relative inline-flex items-center mr-1 px-2 py-2 rounded-full shadow-xs text-sm border ${e.border_color} ${e.color} ${e.background}`)
          }, M, 2)
        ]),
        r("span", null, [
          r("a", {
            onClick: t[3] || (t[3] = (o) => e.changePage(e.total_pages)),
            class: n(`relative inline-flex items-center cursor-pointer px-1 py-2 rounded-full shadow-xs text-sm border ${e.border_color} ${e.color} ${e.background}`)
          }, " Last ", 2)
        ])
      ])
    ]),
    r("div", E, [
      e.show_text ? (s(), a("span", N, [
        r("p", z, [
          d(l(e.text.one) + " ", 1),
          r("span", j, l(e.current_page), 1),
          d(" " + l(e.text.two) + " ", 1),
          r("span", F, l(e.total_pages), 1),
          d(" " + l(e.text.three) + " ", 1),
          r("span", V, l(e.total), 1),
          d(" " + l(e.text.four), 1)
        ])
      ])) : i("", !0),
      r("nav", D, [
        r("span", null, [
          r("a", {
            onClick: t[4] || (t[4] = (o) => e.changePage(1)),
            class: n(`relative mr-2 inline-flex rounded-full shadow-xs items-center px-2 py-2 border ${e.border_color} ${e.background} text-sm font-medium ${e.color}`)
          }, O, 2)
        ]),
        r("span", null, [
          r("a", {
            onClick: t[5] || (t[5] = (o) => e.changePage(e.current_page - 1)),
            class: n(`relative mr-2 inline-flex rounded-full shadow-xs items-center px-2 py-2 border ${e.border_color} ${e.background} text-sm font-medium ${e.color}`)
          }, G, 2)
        ]),
        e.hasFirst() ? (s(), a("span", H, [
          r("a", {
            class: n(`relative cursor-pointer inline-flex items-center rounded-full mr-2 shadow-xs px-4 py-2 border ${e.border_color} ${e.background} text-sm font-medium ${e.color}`),
            onClick: t[6] || (t[6] = g((o) => e.changePage(1), ["prevent"]))
          }, J, 2)
        ])) : i("", !0),
        e.hasFirst() ? (s(), a("a", {
          key: 1,
          onClick: t[7] || (t[7] = (o) => e.less()),
          class: "relative inline-flex items-center cursor-pointer px-4 py-2 mr-2 ml-1 bg-white text-sm font-medium text-gray-700"
        }, "...")) : i("", !0),
        (s(!0), a(m, null, f(e.pages, (o, p) => (s(), a("span", { key: p }, [
          r("a", {
            class: n([[e.current_page === o ? `${e.active_background} ${e.active_color} border ${e.active_border_color}` : `${e.background} border ${e.border_color}`], "relative inline-flex items-center mr-2 px-4 py-2 rounded-full cursor-pointer shadow-xs text-sm font-medium"]),
            onClick: g((v) => e.changePage(o), ["prevent"])
          }, [
            r("span", {
              class: n([e.current_page === o ? "text-white" : ""])
            }, l(o), 3)
          ], 10, K)
        ]))), 128)),
        e.showLast() ? (s(), a("a", {
          key: 2,
          onClick: t[8] || (t[8] = (o) => e.more()),
          class: "relative inline-flex cursor-pointer mr-2 items-center px-4 py-2 text-sm font-medium text-gray-700"
        }, "...")) : i("", !0),
        r("span", null, [
          r("a", {
            onClick: t[9] || (t[9] = (o) => e.changePage(e.current_page + 1)),
            class: n(`relative inline-flex items-center mr-2 px-2 py-2 rounded-full shadow-xs bg-white text-sm font-medium border ${e.border_color} ${e.color} ${e.background}`)
          }, U, 2)
        ]),
        r("span", null, [
          r("a", {
            onClick: t[10] || (t[10] = (o) => e.changePage(e.total_pages)),
            class: n(`relative inline-flex items-center px-2 py-2 rounded-full shadow-xs text-sm font-medium border ${e.border_color} ${e.color} ${e.background}`)
          }, X, 2)
        ])
      ])
    ])
  ])) : i("", !0);
}
const re = /* @__PURE__ */ k($, [["render", Y]]);
export {
  re as Vue3TailwindPagination
};
